require "a_d/engine"

module AD
	class Connection
		attr_accessor :host, :tree_base, :port, :email, :password, :client

		def initialize host, email, password, tree_base:nil, port:389
			@host = host
			@email = email
			@password = password
			@tree_base = tree_base
			@port = port

			@client = Net::LDAP.new host: @host,
			port:@port,
			auth: {
			method: :simple,
				:username => @email,
				:password => @password
			}
		end

	end

	class Person
		attr_accessor :client, :email, :password, :host, :attributes

		def initialize email, password, connection:nil, host:nil, port:nil
			@conection = connection
			@client = connection.blank? ? nil : connection[:client]
			@email = email
			@password = password
			@host = host
			@port = port
		end

		def get_client
			return @client unless @client.blank?
			return client_with_self	# to use the current user's credentials for the connection rather than the connection's credentials
		end

		def client_with_self
			@client = Net::LDAP.new host: @host || @connection.host,
			port: @port || (@connection.blank? ? 389 : @connection.port),
			auth: {
			method: :simple,
				:username => @email,
				:password => @password
			}
		end

		def is_user? client:get_client
			begin
				return client.bind
			rescue	Exception => e
				puts "Error: #{e.message}"
				return false
			end
		end

		def attributes user_root:nil, username_field:nil
			get_attributes user_root:user_root, username_field:username_field  if @attributes.blank?
			return @attributes
		end

		def get_attributes client:get_client, user_root:nil, username_field:nil
			filter = Net::LDAP::Filter.eq username_field, email
			@attributes = client.search base:user_root, filter:filter
		end
	end
end
